// Generated by rstantools.  Do not edit by hand.

/*
    BASiCStan is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    BASiCStan is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with BASiCStan.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#include <rstan/rstaninc.hpp>
// Code generated by Stan version 2.21.0
#include <stan/model/model_header.hpp>
namespace model_basics_regression_namespace {
using std::istream;
using std::string;
using std::stringstream;
using std::vector;
using stan::io::dump;
using stan::math::lgamma;
using stan::model::prob_grad;
using namespace stan::math;
static int current_statement_begin__;
stan::io::program_reader prog_reader__() {
    stan::io::program_reader reader;
    reader.add_event(0, 0, "start", "model_basics_regression");
    reader.add_event(96, 94, "end", "model_basics_regression");
    return reader;
}
template <typename T1__, typename T2__, typename T3__>
Eigen::Matrix<typename boost::math::tools::promote_args<T1__, T2__, T3__>::type, Eigen::Dynamic, Eigen::Dynamic>
designMatrix(const int& l,
                 const Eigen::Matrix<T1__, Eigen::Dynamic, 1>& log_mu,
                 const T2__& rbf_variance,
                 const Eigen::Matrix<T3__, Eigen::Dynamic, 1>& ml,
                 const int& q, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T1__, T2__, T3__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 10;
        local_scalar_t__ h(DUMMY_VAR__);
        (void) h;  // dummy to suppress unused var warning
        stan::math::initialize(h, DUMMY_VAR__);
        stan::math::fill(h, DUMMY_VAR__);
        current_statement_begin__ = 11;
        validate_non_negative_index("X", "q", q);
        validate_non_negative_index("X", "l", l);
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> X(q, l);
        stan::math::initialize(X, DUMMY_VAR__);
        stan::math::fill(X, DUMMY_VAR__);
        current_statement_begin__ = 12;
        stan::math::assign(h, ((get_base1(ml, 2, "ml", 1) - get_base1(ml, 1, "ml", 1)) * rbf_variance));
        current_statement_begin__ = 13;
        for (int i = 1; i <= q; ++i) {
            current_statement_begin__ = 14;
            for (int j = 1; j <= l; ++j) {
                current_statement_begin__ = 15;
                stan::model::assign(X, 
                            stan::model::cons_list(stan::model::index_uni(i), stan::model::cons_list(stan::model::index_uni(j), stan::model::nil_index_list())), 
                            1, 
                            "assigning variable X");
            }
        }
        current_statement_begin__ = 18;
        stan::model::assign(X, 
                    stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(2), stan::model::nil_index_list())), 
                    log_mu, 
                    "assigning variable X");
        current_statement_begin__ = 19;
        for (int i = 1; i <= (l - 2); ++i) {
            {
            current_statement_begin__ = 20;
            validate_non_negative_index("tmp", "q", q);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> tmp(q);
            stan::math::initialize(tmp, DUMMY_VAR__);
            stan::math::fill(tmp, DUMMY_VAR__);
            current_statement_begin__ = 21;
            for (int j = 1; j <= q; ++j) {
                current_statement_begin__ = 22;
                stan::model::assign(tmp, 
                            stan::model::cons_list(stan::model::index_uni(j), stan::model::nil_index_list()), 
                            pow((get_base1(log_mu, j, "log_mu", 1) - get_base1(ml, i, "ml", 1)), 2), 
                            "assigning variable tmp");
            }
            current_statement_begin__ = 24;
            stan::model::assign(X, 
                        stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni((i + 2)), stan::model::nil_index_list())), 
                        stan::math::exp(divide(multiply(-(0.5), tmp), pow(h, 2))), 
                        "assigning variable X");
            }
        }
        current_statement_begin__ = 26;
        return stan::math::promote_scalar<fun_return_scalar_t__>(X);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct designMatrix_functor__ {
    template <typename T1__, typename T2__, typename T3__>
        Eigen::Matrix<typename boost::math::tools::promote_args<T1__, T2__, T3__>::type, Eigen::Dynamic, Eigen::Dynamic>
    operator()(const int& l,
                 const Eigen::Matrix<T1__, Eigen::Dynamic, 1>& log_mu,
                 const T2__& rbf_variance,
                 const Eigen::Matrix<T3__, Eigen::Dynamic, 1>& ml,
                 const int& q, std::ostream* pstream__) const {
        return designMatrix(l, log_mu, rbf_variance, ml, q, pstream__);
    }
};
#include <stan_meta_header.hpp>
class model_basics_regression
  : public stan::model::model_base_crtp<model_basics_regression> {
private:
        int q;
        int n;
        int sq;
        int p;
        std::vector<std::vector<int> > counts;
        std::vector<std::vector<int> > spikes;
        double as;
        double bs;
        double atheta;
        double btheta;
        matrix_d batch_design;
        vector_d aphi;
        vector_d mu_mu;
        double smu;
        double astwo;
        double bstwo;
        int l;
        vector_d mbeta;
        matrix_d vbeta;
        double rbf_variance;
        vector_d ml;
        double eta;
        vector_d spike_levels;
public:
    model_basics_regression(stan::io::var_context& context__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, 0, pstream__);
    }
    model_basics_regression(stan::io::var_context& context__,
        unsigned int random_seed__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, random_seed__, pstream__);
    }
    void ctor_body(stan::io::var_context& context__,
                   unsigned int random_seed__,
                   std::ostream* pstream__) {
        typedef double local_scalar_t__;
        boost::ecuyer1988 base_rng__ =
          stan::services::util::create_rng(random_seed__, 0);
        (void) base_rng__;  // suppress unused var warning
        current_statement_begin__ = -1;
        static const char* function__ = "model_basics_regression_namespace::model_basics_regression";
        (void) function__;  // dummy to suppress unused var warning
        size_t pos__;
        (void) pos__;  // dummy to suppress unused var warning
        std::vector<int> vals_i__;
        std::vector<double> vals_r__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        try {
            // initialize data block variables from context__
            current_statement_begin__ = 31;
            context__.validate_dims("data initialization", "q", "int", context__.to_vec());
            q = int(0);
            vals_i__ = context__.vals_i("q");
            pos__ = 0;
            q = vals_i__[pos__++];
            current_statement_begin__ = 32;
            context__.validate_dims("data initialization", "n", "int", context__.to_vec());
            n = int(0);
            vals_i__ = context__.vals_i("n");
            pos__ = 0;
            n = vals_i__[pos__++];
            current_statement_begin__ = 33;
            context__.validate_dims("data initialization", "sq", "int", context__.to_vec());
            sq = int(0);
            vals_i__ = context__.vals_i("sq");
            pos__ = 0;
            sq = vals_i__[pos__++];
            current_statement_begin__ = 34;
            context__.validate_dims("data initialization", "p", "int", context__.to_vec());
            p = int(0);
            vals_i__ = context__.vals_i("p");
            pos__ = 0;
            p = vals_i__[pos__++];
            current_statement_begin__ = 35;
            validate_non_negative_index("counts", "q", q);
            validate_non_negative_index("counts", "n", n);
            context__.validate_dims("data initialization", "counts", "int", context__.to_vec(q,n));
            counts = std::vector<std::vector<int> >(q, std::vector<int>(n, int(0)));
            vals_i__ = context__.vals_i("counts");
            pos__ = 0;
            size_t counts_k_0_max__ = q;
            size_t counts_k_1_max__ = n;
            for (size_t k_1__ = 0; k_1__ < counts_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < counts_k_0_max__; ++k_0__) {
                    counts[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            size_t counts_i_0_max__ = q;
            size_t counts_i_1_max__ = n;
            for (size_t i_0__ = 0; i_0__ < counts_i_0_max__; ++i_0__) {
                for (size_t i_1__ = 0; i_1__ < counts_i_1_max__; ++i_1__) {
                    check_greater_or_equal(function__, "counts[i_0__][i_1__]", counts[i_0__][i_1__], 0);
                }
            }
            current_statement_begin__ = 36;
            validate_non_negative_index("spikes", "sq", sq);
            validate_non_negative_index("spikes", "n", n);
            context__.validate_dims("data initialization", "spikes", "int", context__.to_vec(sq,n));
            spikes = std::vector<std::vector<int> >(sq, std::vector<int>(n, int(0)));
            vals_i__ = context__.vals_i("spikes");
            pos__ = 0;
            size_t spikes_k_0_max__ = sq;
            size_t spikes_k_1_max__ = n;
            for (size_t k_1__ = 0; k_1__ < spikes_k_1_max__; ++k_1__) {
                for (size_t k_0__ = 0; k_0__ < spikes_k_0_max__; ++k_0__) {
                    spikes[k_0__][k_1__] = vals_i__[pos__++];
                }
            }
            size_t spikes_i_0_max__ = sq;
            size_t spikes_i_1_max__ = n;
            for (size_t i_0__ = 0; i_0__ < spikes_i_0_max__; ++i_0__) {
                for (size_t i_1__ = 0; i_1__ < spikes_i_1_max__; ++i_1__) {
                    check_greater_or_equal(function__, "spikes[i_0__][i_1__]", spikes[i_0__][i_1__], 0);
                }
            }
            current_statement_begin__ = 37;
            context__.validate_dims("data initialization", "as", "double", context__.to_vec());
            as = double(0);
            vals_r__ = context__.vals_r("as");
            pos__ = 0;
            as = vals_r__[pos__++];
            current_statement_begin__ = 38;
            context__.validate_dims("data initialization", "bs", "double", context__.to_vec());
            bs = double(0);
            vals_r__ = context__.vals_r("bs");
            pos__ = 0;
            bs = vals_r__[pos__++];
            current_statement_begin__ = 39;
            context__.validate_dims("data initialization", "atheta", "double", context__.to_vec());
            atheta = double(0);
            vals_r__ = context__.vals_r("atheta");
            pos__ = 0;
            atheta = vals_r__[pos__++];
            current_statement_begin__ = 40;
            context__.validate_dims("data initialization", "btheta", "double", context__.to_vec());
            btheta = double(0);
            vals_r__ = context__.vals_r("btheta");
            pos__ = 0;
            btheta = vals_r__[pos__++];
            current_statement_begin__ = 41;
            validate_non_negative_index("batch_design", "n", n);
            validate_non_negative_index("batch_design", "p", p);
            context__.validate_dims("data initialization", "batch_design", "matrix_d", context__.to_vec(n,p));
            batch_design = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(n, p);
            vals_r__ = context__.vals_r("batch_design");
            pos__ = 0;
            size_t batch_design_j_2_max__ = p;
            size_t batch_design_j_1_max__ = n;
            for (size_t j_2__ = 0; j_2__ < batch_design_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < batch_design_j_1_max__; ++j_1__) {
                    batch_design(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 42;
            validate_non_negative_index("aphi", "n", n);
            context__.validate_dims("data initialization", "aphi", "vector_d", context__.to_vec(n));
            aphi = Eigen::Matrix<double, Eigen::Dynamic, 1>(n);
            vals_r__ = context__.vals_r("aphi");
            pos__ = 0;
            size_t aphi_j_1_max__ = n;
            for (size_t j_1__ = 0; j_1__ < aphi_j_1_max__; ++j_1__) {
                aphi(j_1__) = vals_r__[pos__++];
            }
            current_statement_begin__ = 43;
            validate_non_negative_index("mu_mu", "q", q);
            context__.validate_dims("data initialization", "mu_mu", "vector_d", context__.to_vec(q));
            mu_mu = Eigen::Matrix<double, Eigen::Dynamic, 1>(q);
            vals_r__ = context__.vals_r("mu_mu");
            pos__ = 0;
            size_t mu_mu_j_1_max__ = q;
            for (size_t j_1__ = 0; j_1__ < mu_mu_j_1_max__; ++j_1__) {
                mu_mu(j_1__) = vals_r__[pos__++];
            }
            current_statement_begin__ = 44;
            context__.validate_dims("data initialization", "smu", "double", context__.to_vec());
            smu = double(0);
            vals_r__ = context__.vals_r("smu");
            pos__ = 0;
            smu = vals_r__[pos__++];
            current_statement_begin__ = 45;
            context__.validate_dims("data initialization", "astwo", "double", context__.to_vec());
            astwo = double(0);
            vals_r__ = context__.vals_r("astwo");
            pos__ = 0;
            astwo = vals_r__[pos__++];
            current_statement_begin__ = 46;
            context__.validate_dims("data initialization", "bstwo", "double", context__.to_vec());
            bstwo = double(0);
            vals_r__ = context__.vals_r("bstwo");
            pos__ = 0;
            bstwo = vals_r__[pos__++];
            current_statement_begin__ = 47;
            context__.validate_dims("data initialization", "l", "int", context__.to_vec());
            l = int(0);
            vals_i__ = context__.vals_i("l");
            pos__ = 0;
            l = vals_i__[pos__++];
            current_statement_begin__ = 48;
            validate_non_negative_index("mbeta", "l", l);
            context__.validate_dims("data initialization", "mbeta", "vector_d", context__.to_vec(l));
            mbeta = Eigen::Matrix<double, Eigen::Dynamic, 1>(l);
            vals_r__ = context__.vals_r("mbeta");
            pos__ = 0;
            size_t mbeta_j_1_max__ = l;
            for (size_t j_1__ = 0; j_1__ < mbeta_j_1_max__; ++j_1__) {
                mbeta(j_1__) = vals_r__[pos__++];
            }
            current_statement_begin__ = 49;
            validate_non_negative_index("vbeta", "l", l);
            validate_non_negative_index("vbeta", "l", l);
            context__.validate_dims("data initialization", "vbeta", "matrix_d", context__.to_vec(l,l));
            vbeta = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(l, l);
            vals_r__ = context__.vals_r("vbeta");
            pos__ = 0;
            size_t vbeta_j_2_max__ = l;
            size_t vbeta_j_1_max__ = l;
            for (size_t j_2__ = 0; j_2__ < vbeta_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < vbeta_j_1_max__; ++j_1__) {
                    vbeta(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 50;
            context__.validate_dims("data initialization", "rbf_variance", "double", context__.to_vec());
            rbf_variance = double(0);
            vals_r__ = context__.vals_r("rbf_variance");
            pos__ = 0;
            rbf_variance = vals_r__[pos__++];
            current_statement_begin__ = 51;
            validate_non_negative_index("ml", "(l - 2)", (l - 2));
            context__.validate_dims("data initialization", "ml", "vector_d", context__.to_vec((l - 2)));
            ml = Eigen::Matrix<double, Eigen::Dynamic, 1>((l - 2));
            vals_r__ = context__.vals_r("ml");
            pos__ = 0;
            size_t ml_j_1_max__ = (l - 2);
            for (size_t j_1__ = 0; j_1__ < ml_j_1_max__; ++j_1__) {
                ml(j_1__) = vals_r__[pos__++];
            }
            current_statement_begin__ = 52;
            context__.validate_dims("data initialization", "eta", "double", context__.to_vec());
            eta = double(0);
            vals_r__ = context__.vals_r("eta");
            pos__ = 0;
            eta = vals_r__[pos__++];
            current_statement_begin__ = 53;
            validate_non_negative_index("spike_levels", "sq", sq);
            context__.validate_dims("data initialization", "spike_levels", "vector_d", context__.to_vec(sq));
            spike_levels = Eigen::Matrix<double, Eigen::Dynamic, 1>(sq);
            vals_r__ = context__.vals_r("spike_levels");
            pos__ = 0;
            size_t spike_levels_j_1_max__ = sq;
            for (size_t j_1__ = 0; j_1__ < spike_levels_j_1_max__; ++j_1__) {
                spike_levels(j_1__) = vals_r__[pos__++];
            }
            // initialize transformed data variables
            // execute transformed data statements
            // validate transformed data
            // validate, set parameter ranges
            num_params_r__ = 0U;
            param_ranges_i__.clear();
            current_statement_begin__ = 57;
            validate_non_negative_index("log_mu", "q", q);
            num_params_r__ += q;
            current_statement_begin__ = 58;
            validate_non_negative_index("delta", "q", q);
            num_params_r__ += q;
            current_statement_begin__ = 59;
            validate_non_negative_index("tphi", "n", n);
            num_params_r__ += (n - 1);
            current_statement_begin__ = 60;
            validate_non_negative_index("nu", "n", n);
            num_params_r__ += (1 * n);
            current_statement_begin__ = 61;
            validate_non_negative_index("s", "n", n);
            num_params_r__ += n;
            current_statement_begin__ = 62;
            validate_non_negative_index("theta", "p", p);
            num_params_r__ += p;
            current_statement_begin__ = 63;
            validate_non_negative_index("beta", "l", l);
            num_params_r__ += l;
            current_statement_begin__ = 64;
            num_params_r__ += 1;
            current_statement_begin__ = 65;
            validate_non_negative_index("lambda", "q", q);
            num_params_r__ += q;
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    ~model_basics_regression() { }
    void transform_inits(const stan::io::var_context& context__,
                         std::vector<int>& params_i__,
                         std::vector<double>& params_r__,
                         std::ostream* pstream__) const {
        typedef double local_scalar_t__;
        stan::io::writer<double> writer__(params_r__, params_i__);
        size_t pos__;
        (void) pos__; // dummy call to supress warning
        std::vector<double> vals_r__;
        std::vector<int> vals_i__;
        current_statement_begin__ = 57;
        if (!(context__.contains_r("log_mu")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable log_mu missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("log_mu");
        pos__ = 0U;
        validate_non_negative_index("log_mu", "q", q);
        context__.validate_dims("parameter initialization", "log_mu", "vector_d", context__.to_vec(q));
        Eigen::Matrix<double, Eigen::Dynamic, 1> log_mu(q);
        size_t log_mu_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < log_mu_j_1_max__; ++j_1__) {
            log_mu(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_unconstrain(log_mu);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable log_mu: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 58;
        if (!(context__.contains_r("delta")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable delta missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("delta");
        pos__ = 0U;
        validate_non_negative_index("delta", "q", q);
        context__.validate_dims("parameter initialization", "delta", "vector_d", context__.to_vec(q));
        Eigen::Matrix<double, Eigen::Dynamic, 1> delta(q);
        size_t delta_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < delta_j_1_max__; ++j_1__) {
            delta(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_lb_unconstrain(0, delta);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable delta: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 59;
        if (!(context__.contains_r("tphi")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable tphi missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("tphi");
        pos__ = 0U;
        validate_non_negative_index("tphi", "n", n);
        context__.validate_dims("parameter initialization", "tphi", "vector_d", context__.to_vec(n));
        Eigen::Matrix<double, Eigen::Dynamic, 1> tphi(n);
        size_t tphi_j_1_max__ = n;
        for (size_t j_1__ = 0; j_1__ < tphi_j_1_max__; ++j_1__) {
            tphi(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.simplex_unconstrain(tphi);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable tphi: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 60;
        if (!(context__.contains_r("nu")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable nu missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("nu");
        pos__ = 0U;
        validate_non_negative_index("nu", "n", n);
        context__.validate_dims("parameter initialization", "nu", "double", context__.to_vec(n));
        std::vector<double> nu(n, double(0));
        size_t nu_k_0_max__ = n;
        for (size_t k_0__ = 0; k_0__ < nu_k_0_max__; ++k_0__) {
            nu[k_0__] = vals_r__[pos__++];
        }
        size_t nu_i_0_max__ = n;
        for (size_t i_0__ = 0; i_0__ < nu_i_0_max__; ++i_0__) {
            try {
                writer__.scalar_lb_unconstrain(0, nu[i_0__]);
            } catch (const std::exception& e) {
                stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable nu: ") + e.what()), current_statement_begin__, prog_reader__());
            }
        }
        current_statement_begin__ = 61;
        if (!(context__.contains_r("s")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable s missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("s");
        pos__ = 0U;
        validate_non_negative_index("s", "n", n);
        context__.validate_dims("parameter initialization", "s", "vector_d", context__.to_vec(n));
        Eigen::Matrix<double, Eigen::Dynamic, 1> s(n);
        size_t s_j_1_max__ = n;
        for (size_t j_1__ = 0; j_1__ < s_j_1_max__; ++j_1__) {
            s(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_lb_unconstrain(0, s);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable s: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 62;
        if (!(context__.contains_r("theta")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable theta missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("theta");
        pos__ = 0U;
        validate_non_negative_index("theta", "p", p);
        context__.validate_dims("parameter initialization", "theta", "vector_d", context__.to_vec(p));
        Eigen::Matrix<double, Eigen::Dynamic, 1> theta(p);
        size_t theta_j_1_max__ = p;
        for (size_t j_1__ = 0; j_1__ < theta_j_1_max__; ++j_1__) {
            theta(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_lb_unconstrain(0, theta);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable theta: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 63;
        if (!(context__.contains_r("beta")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable beta missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("beta");
        pos__ = 0U;
        validate_non_negative_index("beta", "l", l);
        context__.validate_dims("parameter initialization", "beta", "vector_d", context__.to_vec(l));
        Eigen::Matrix<double, Eigen::Dynamic, 1> beta(l);
        size_t beta_j_1_max__ = l;
        for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
            beta(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_unconstrain(beta);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable beta: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 64;
        if (!(context__.contains_r("stwo")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable stwo missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("stwo");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "stwo", "double", context__.to_vec());
        double stwo(0);
        stwo = vals_r__[pos__++];
        try {
            writer__.scalar_lb_unconstrain(0, stwo);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable stwo: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 65;
        if (!(context__.contains_r("lambda")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable lambda missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("lambda");
        pos__ = 0U;
        validate_non_negative_index("lambda", "q", q);
        context__.validate_dims("parameter initialization", "lambda", "vector_d", context__.to_vec(q));
        Eigen::Matrix<double, Eigen::Dynamic, 1> lambda(q);
        size_t lambda_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < lambda_j_1_max__; ++j_1__) {
            lambda(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_lb_unconstrain(0, lambda);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable lambda: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        params_r__ = writer__.data_r();
        params_i__ = writer__.data_i();
    }
    void transform_inits(const stan::io::var_context& context,
                         Eigen::Matrix<double, Eigen::Dynamic, 1>& params_r,
                         std::ostream* pstream__) const {
      std::vector<double> params_r_vec;
      std::vector<int> params_i_vec;
      transform_inits(context, params_i_vec, params_r_vec, pstream__);
      params_r.resize(params_r_vec.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r(i) = params_r_vec[i];
    }
    template <bool propto__, bool jacobian__, typename T__>
    T__ log_prob(std::vector<T__>& params_r__,
                 std::vector<int>& params_i__,
                 std::ostream* pstream__ = 0) const {
        typedef T__ local_scalar_t__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // dummy to suppress unused var warning
        T__ lp__(0.0);
        stan::math::accumulator<T__> lp_accum__;
        try {
            stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
            // model parameters
            current_statement_begin__ = 57;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> log_mu;
            (void) log_mu;  // dummy to suppress unused var warning
            if (jacobian__)
                log_mu = in__.vector_constrain(q, lp__);
            else
                log_mu = in__.vector_constrain(q);
            current_statement_begin__ = 58;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> delta;
            (void) delta;  // dummy to suppress unused var warning
            if (jacobian__)
                delta = in__.vector_lb_constrain(0, q, lp__);
            else
                delta = in__.vector_lb_constrain(0, q);
            current_statement_begin__ = 59;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> tphi;
            (void) tphi;  // dummy to suppress unused var warning
            if (jacobian__)
                tphi = in__.simplex_constrain(n, lp__);
            else
                tphi = in__.simplex_constrain(n);
            current_statement_begin__ = 60;
            std::vector<local_scalar_t__> nu;
            size_t nu_d_0_max__ = n;
            nu.reserve(nu_d_0_max__);
            for (size_t d_0__ = 0; d_0__ < nu_d_0_max__; ++d_0__) {
                if (jacobian__)
                    nu.push_back(in__.scalar_lb_constrain(0, lp__));
                else
                    nu.push_back(in__.scalar_lb_constrain(0));
            }
            current_statement_begin__ = 61;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> s;
            (void) s;  // dummy to suppress unused var warning
            if (jacobian__)
                s = in__.vector_lb_constrain(0, n, lp__);
            else
                s = in__.vector_lb_constrain(0, n);
            current_statement_begin__ = 62;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> theta;
            (void) theta;  // dummy to suppress unused var warning
            if (jacobian__)
                theta = in__.vector_lb_constrain(0, p, lp__);
            else
                theta = in__.vector_lb_constrain(0, p);
            current_statement_begin__ = 63;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> beta;
            (void) beta;  // dummy to suppress unused var warning
            if (jacobian__)
                beta = in__.vector_constrain(l, lp__);
            else
                beta = in__.vector_constrain(l);
            current_statement_begin__ = 64;
            local_scalar_t__ stwo;
            (void) stwo;  // dummy to suppress unused var warning
            if (jacobian__)
                stwo = in__.scalar_lb_constrain(0, lp__);
            else
                stwo = in__.scalar_lb_constrain(0);
            current_statement_begin__ = 65;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> lambda;
            (void) lambda;  // dummy to suppress unused var warning
            if (jacobian__)
                lambda = in__.vector_lb_constrain(0, q, lp__);
            else
                lambda = in__.vector_lb_constrain(0, q);
            // transformed parameters
            current_statement_begin__ = 69;
            validate_non_negative_index("theta_vector", "n", n);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> theta_vector(n);
            stan::math::initialize(theta_vector, DUMMY_VAR__);
            stan::math::fill(theta_vector, DUMMY_VAR__);
            stan::math::assign(theta_vector,multiply(batch_design, theta));
            current_statement_begin__ = 70;
            validate_non_negative_index("phi", "n", n);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> phi(n);
            stan::math::initialize(phi, DUMMY_VAR__);
            stan::math::fill(phi, DUMMY_VAR__);
            stan::math::assign(phi,multiply(tphi, n));
            current_statement_begin__ = 71;
            validate_non_negative_index("mu", "q", q);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> mu(q);
            stan::math::initialize(mu, DUMMY_VAR__);
            stan::math::fill(mu, DUMMY_VAR__);
            stan::math::assign(mu,stan::math::exp(log_mu));
            current_statement_begin__ = 72;
            validate_non_negative_index("fu", "q", q);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> fu(q);
            stan::math::initialize(fu, DUMMY_VAR__);
            stan::math::fill(fu, DUMMY_VAR__);
            stan::math::assign(fu,multiply(designMatrix(l, log_mu, rbf_variance, ml, q, pstream__), beta));
            current_statement_begin__ = 73;
            validate_non_negative_index("epsilon", "q", q);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> epsilon(q);
            stan::math::initialize(epsilon, DUMMY_VAR__);
            stan::math::fill(epsilon, DUMMY_VAR__);
            stan::math::assign(epsilon,subtract(stan::math::log(delta), fu));
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            current_statement_begin__ = 69;
            size_t theta_vector_j_1_max__ = n;
            for (size_t j_1__ = 0; j_1__ < theta_vector_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(theta_vector(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: theta_vector" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable theta_vector: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            check_greater_or_equal(function__, "theta_vector", theta_vector, 0);
            current_statement_begin__ = 70;
            size_t phi_j_1_max__ = n;
            for (size_t j_1__ = 0; j_1__ < phi_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(phi(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: phi" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable phi: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            check_greater_or_equal(function__, "phi", phi, 0);
            current_statement_begin__ = 71;
            size_t mu_j_1_max__ = q;
            for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(mu(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: mu" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable mu: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            check_greater_or_equal(function__, "mu", mu, 0);
            current_statement_begin__ = 72;
            size_t fu_j_1_max__ = q;
            for (size_t j_1__ = 0; j_1__ < fu_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(fu(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: fu" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable fu: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            current_statement_begin__ = 73;
            size_t epsilon_j_1_max__ = q;
            for (size_t j_1__ = 0; j_1__ < epsilon_j_1_max__; ++j_1__) {
                if (stan::math::is_uninitialized(epsilon(j_1__))) {
                    std::stringstream msg__;
                    msg__ << "Undefined transformed parameter: epsilon" << "(" << j_1__ << ")";
                    stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable epsilon: ") + msg__.str()), current_statement_begin__, prog_reader__());
                }
            }
            // model body
            current_statement_begin__ = 78;
            lp_accum__.add(gamma_log<propto__>(theta, atheta, btheta));
            current_statement_begin__ = 79;
            lp_accum__.add(dirichlet_log<propto__>(tphi, aphi));
            current_statement_begin__ = 80;
            lp_accum__.add(inv_gamma_log<propto__>(stwo, astwo, bstwo));
            current_statement_begin__ = 81;
            lp_accum__.add(multi_normal_log<propto__>(beta, mbeta, multiply(stwo, vbeta)));
            current_statement_begin__ = 82;
            lp_accum__.add(normal_log<propto__>(log_mu, mu_mu, smu));
            current_statement_begin__ = 83;
            lp_accum__.add(gamma_log<propto__>(lambda, (eta / 2), (eta / 2)));
            current_statement_begin__ = 84;
            lp_accum__.add(lognormal_log<propto__>(delta, fu, elt_divide(stwo, stan::math::sqrt(lambda))));
            current_statement_begin__ = 85;
            lp_accum__.add(gamma_log<propto__>(s, as, bs));
            current_statement_begin__ = 86;
            lp_accum__.add(gamma_log<propto__>(nu, elt_divide(1.0, theta_vector), elt_divide(1.0, elt_multiply(s, theta_vector))));
            current_statement_begin__ = 87;
            for (int j = 1; j <= n; ++j) {
                current_statement_begin__ = 88;
                lp_accum__.add(neg_binomial_2_log_log<propto__>(stan::model::rvalue(counts, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(j), stan::model::nil_index_list())), "counts"), add((stan::math::log(get_base1(phi, j, "phi", 1)) + stan::math::log(get_base1(nu, j, "nu", 1))), log_mu), elt_divide(1.0, delta)));
                current_statement_begin__ = 92;
                lp_accum__.add(poisson_log<propto__>(stan::model::rvalue(spikes, stan::model::cons_list(stan::model::index_omni(), stan::model::cons_list(stan::model::index_uni(j), stan::model::nil_index_list())), "spikes"), multiply(get_base1(nu, j, "nu", 1), spike_levels)));
            }
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
        lp_accum__.add(lp__);
        return lp_accum__.sum();
    } // log_prob()
    template <bool propto, bool jacobian, typename T_>
    T_ log_prob(Eigen::Matrix<T_,Eigen::Dynamic,1>& params_r,
               std::ostream* pstream = 0) const {
      std::vector<T_> vec_params_r;
      vec_params_r.reserve(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        vec_params_r.push_back(params_r(i));
      std::vector<int> vec_params_i;
      return log_prob<propto,jacobian,T_>(vec_params_r, vec_params_i, pstream);
    }
    void get_param_names(std::vector<std::string>& names__) const {
        names__.resize(0);
        names__.push_back("log_mu");
        names__.push_back("delta");
        names__.push_back("tphi");
        names__.push_back("nu");
        names__.push_back("s");
        names__.push_back("theta");
        names__.push_back("beta");
        names__.push_back("stwo");
        names__.push_back("lambda");
        names__.push_back("theta_vector");
        names__.push_back("phi");
        names__.push_back("mu");
        names__.push_back("fu");
        names__.push_back("epsilon");
    }
    void get_dims(std::vector<std::vector<size_t> >& dimss__) const {
        dimss__.resize(0);
        std::vector<size_t> dims__;
        dims__.resize(0);
        dims__.push_back(q);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(q);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(n);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(n);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(n);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(p);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(l);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(q);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(n);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(n);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(q);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(q);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(q);
        dimss__.push_back(dims__);
    }
    template <typename RNG>
    void write_array(RNG& base_rng__,
                     std::vector<double>& params_r__,
                     std::vector<int>& params_i__,
                     std::vector<double>& vars__,
                     bool include_tparams__ = true,
                     bool include_gqs__ = true,
                     std::ostream* pstream__ = 0) const {
        typedef double local_scalar_t__;
        vars__.resize(0);
        stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
        static const char* function__ = "model_basics_regression_namespace::write_array";
        (void) function__;  // dummy to suppress unused var warning
        // read-transform, write parameters
        Eigen::Matrix<double, Eigen::Dynamic, 1> log_mu = in__.vector_constrain(q);
        size_t log_mu_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < log_mu_j_1_max__; ++j_1__) {
            vars__.push_back(log_mu(j_1__));
        }
        Eigen::Matrix<double, Eigen::Dynamic, 1> delta = in__.vector_lb_constrain(0, q);
        size_t delta_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < delta_j_1_max__; ++j_1__) {
            vars__.push_back(delta(j_1__));
        }
        Eigen::Matrix<double, Eigen::Dynamic, 1> tphi = in__.simplex_constrain(n);
        size_t tphi_j_1_max__ = n;
        for (size_t j_1__ = 0; j_1__ < tphi_j_1_max__; ++j_1__) {
            vars__.push_back(tphi(j_1__));
        }
        std::vector<double> nu;
        size_t nu_d_0_max__ = n;
        nu.reserve(nu_d_0_max__);
        for (size_t d_0__ = 0; d_0__ < nu_d_0_max__; ++d_0__) {
            nu.push_back(in__.scalar_lb_constrain(0));
        }
        size_t nu_k_0_max__ = n;
        for (size_t k_0__ = 0; k_0__ < nu_k_0_max__; ++k_0__) {
            vars__.push_back(nu[k_0__]);
        }
        Eigen::Matrix<double, Eigen::Dynamic, 1> s = in__.vector_lb_constrain(0, n);
        size_t s_j_1_max__ = n;
        for (size_t j_1__ = 0; j_1__ < s_j_1_max__; ++j_1__) {
            vars__.push_back(s(j_1__));
        }
        Eigen::Matrix<double, Eigen::Dynamic, 1> theta = in__.vector_lb_constrain(0, p);
        size_t theta_j_1_max__ = p;
        for (size_t j_1__ = 0; j_1__ < theta_j_1_max__; ++j_1__) {
            vars__.push_back(theta(j_1__));
        }
        Eigen::Matrix<double, Eigen::Dynamic, 1> beta = in__.vector_constrain(l);
        size_t beta_j_1_max__ = l;
        for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
            vars__.push_back(beta(j_1__));
        }
        double stwo = in__.scalar_lb_constrain(0);
        vars__.push_back(stwo);
        Eigen::Matrix<double, Eigen::Dynamic, 1> lambda = in__.vector_lb_constrain(0, q);
        size_t lambda_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < lambda_j_1_max__; ++j_1__) {
            vars__.push_back(lambda(j_1__));
        }
        double lp__ = 0.0;
        (void) lp__;  // dummy to suppress unused var warning
        stan::math::accumulator<double> lp_accum__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        if (!include_tparams__ && !include_gqs__) return;
        try {
            // declare and define transformed parameters
            current_statement_begin__ = 69;
            validate_non_negative_index("theta_vector", "n", n);
            Eigen::Matrix<double, Eigen::Dynamic, 1> theta_vector(n);
            stan::math::initialize(theta_vector, DUMMY_VAR__);
            stan::math::fill(theta_vector, DUMMY_VAR__);
            stan::math::assign(theta_vector,multiply(batch_design, theta));
            current_statement_begin__ = 70;
            validate_non_negative_index("phi", "n", n);
            Eigen::Matrix<double, Eigen::Dynamic, 1> phi(n);
            stan::math::initialize(phi, DUMMY_VAR__);
            stan::math::fill(phi, DUMMY_VAR__);
            stan::math::assign(phi,multiply(tphi, n));
            current_statement_begin__ = 71;
            validate_non_negative_index("mu", "q", q);
            Eigen::Matrix<double, Eigen::Dynamic, 1> mu(q);
            stan::math::initialize(mu, DUMMY_VAR__);
            stan::math::fill(mu, DUMMY_VAR__);
            stan::math::assign(mu,stan::math::exp(log_mu));
            current_statement_begin__ = 72;
            validate_non_negative_index("fu", "q", q);
            Eigen::Matrix<double, Eigen::Dynamic, 1> fu(q);
            stan::math::initialize(fu, DUMMY_VAR__);
            stan::math::fill(fu, DUMMY_VAR__);
            stan::math::assign(fu,multiply(designMatrix(l, log_mu, rbf_variance, ml, q, pstream__), beta));
            current_statement_begin__ = 73;
            validate_non_negative_index("epsilon", "q", q);
            Eigen::Matrix<double, Eigen::Dynamic, 1> epsilon(q);
            stan::math::initialize(epsilon, DUMMY_VAR__);
            stan::math::fill(epsilon, DUMMY_VAR__);
            stan::math::assign(epsilon,subtract(stan::math::log(delta), fu));
            if (!include_gqs__ && !include_tparams__) return;
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            current_statement_begin__ = 69;
            check_greater_or_equal(function__, "theta_vector", theta_vector, 0);
            current_statement_begin__ = 70;
            check_greater_or_equal(function__, "phi", phi, 0);
            current_statement_begin__ = 71;
            check_greater_or_equal(function__, "mu", mu, 0);
            // write transformed parameters
            if (include_tparams__) {
                size_t theta_vector_j_1_max__ = n;
                for (size_t j_1__ = 0; j_1__ < theta_vector_j_1_max__; ++j_1__) {
                    vars__.push_back(theta_vector(j_1__));
                }
                size_t phi_j_1_max__ = n;
                for (size_t j_1__ = 0; j_1__ < phi_j_1_max__; ++j_1__) {
                    vars__.push_back(phi(j_1__));
                }
                size_t mu_j_1_max__ = q;
                for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                    vars__.push_back(mu(j_1__));
                }
                size_t fu_j_1_max__ = q;
                for (size_t j_1__ = 0; j_1__ < fu_j_1_max__; ++j_1__) {
                    vars__.push_back(fu(j_1__));
                }
                size_t epsilon_j_1_max__ = q;
                for (size_t j_1__ = 0; j_1__ < epsilon_j_1_max__; ++j_1__) {
                    vars__.push_back(epsilon(j_1__));
                }
            }
            if (!include_gqs__) return;
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    template <typename RNG>
    void write_array(RNG& base_rng,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& vars,
                     bool include_tparams = true,
                     bool include_gqs = true,
                     std::ostream* pstream = 0) const {
      std::vector<double> params_r_vec(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r_vec[i] = params_r(i);
      std::vector<double> vars_vec;
      std::vector<int> params_i_vec;
      write_array(base_rng, params_r_vec, params_i_vec, vars_vec, include_tparams, include_gqs, pstream);
      vars.resize(vars_vec.size());
      for (int i = 0; i < vars.size(); ++i)
        vars(i) = vars_vec[i];
    }
    std::string model_name() const {
        return "model_basics_regression";
    }
    void constrained_param_names(std::vector<std::string>& param_names__,
                                 bool include_tparams__ = true,
                                 bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t log_mu_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < log_mu_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "log_mu" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t delta_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < delta_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "delta" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t tphi_j_1_max__ = n;
        for (size_t j_1__ = 0; j_1__ < tphi_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "tphi" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t nu_k_0_max__ = n;
        for (size_t k_0__ = 0; k_0__ < nu_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "nu" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t s_j_1_max__ = n;
        for (size_t j_1__ = 0; j_1__ < s_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "s" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t theta_j_1_max__ = p;
        for (size_t j_1__ = 0; j_1__ < theta_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "theta" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t beta_j_1_max__ = l;
        for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "beta" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "stwo";
        param_names__.push_back(param_name_stream__.str());
        size_t lambda_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < lambda_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "lambda" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t theta_vector_j_1_max__ = n;
            for (size_t j_1__ = 0; j_1__ < theta_vector_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "theta_vector" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t phi_j_1_max__ = n;
            for (size_t j_1__ = 0; j_1__ < phi_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "phi" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t mu_j_1_max__ = q;
            for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "mu" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t fu_j_1_max__ = q;
            for (size_t j_1__ = 0; j_1__ < fu_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "fu" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t epsilon_j_1_max__ = q;
            for (size_t j_1__ = 0; j_1__ < epsilon_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "epsilon" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__) return;
    }
    void unconstrained_param_names(std::vector<std::string>& param_names__,
                                   bool include_tparams__ = true,
                                   bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        size_t log_mu_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < log_mu_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "log_mu" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t delta_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < delta_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "delta" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t tphi_j_1_max__ = (n - 1);
        for (size_t j_1__ = 0; j_1__ < tphi_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "tphi" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t nu_k_0_max__ = n;
        for (size_t k_0__ = 0; k_0__ < nu_k_0_max__; ++k_0__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "nu" << '.' << k_0__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t s_j_1_max__ = n;
        for (size_t j_1__ = 0; j_1__ < s_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "s" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t theta_j_1_max__ = p;
        for (size_t j_1__ = 0; j_1__ < theta_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "theta" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        size_t beta_j_1_max__ = l;
        for (size_t j_1__ = 0; j_1__ < beta_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "beta" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        param_name_stream__.str(std::string());
        param_name_stream__ << "stwo";
        param_names__.push_back(param_name_stream__.str());
        size_t lambda_j_1_max__ = q;
        for (size_t j_1__ = 0; j_1__ < lambda_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "lambda" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t theta_vector_j_1_max__ = n;
            for (size_t j_1__ = 0; j_1__ < theta_vector_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "theta_vector" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t phi_j_1_max__ = n;
            for (size_t j_1__ = 0; j_1__ < phi_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "phi" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t mu_j_1_max__ = q;
            for (size_t j_1__ = 0; j_1__ < mu_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "mu" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t fu_j_1_max__ = q;
            for (size_t j_1__ = 0; j_1__ < fu_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "fu" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
            size_t epsilon_j_1_max__ = q;
            for (size_t j_1__ = 0; j_1__ < epsilon_j_1_max__; ++j_1__) {
                param_name_stream__.str(std::string());
                param_name_stream__ << "epsilon" << '.' << j_1__ + 1;
                param_names__.push_back(param_name_stream__.str());
            }
        }
        if (!include_gqs__) return;
    }
}; // model
}  // namespace
typedef model_basics_regression_namespace::model_basics_regression stan_model;
#ifndef USING_R
stan::model::model_base& new_model(
        stan::io::var_context& data_context,
        unsigned int seed,
        std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
#endif
#endif
